const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const barter_offers = sequelize.define(
    'barter_offers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      offer_details: {
        type: DataTypes.TEXT,
      },

      offer_date: {
        type: DataTypes.DATE,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  barter_offers.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.barter_offers.belongsTo(db.partners, {
      as: 'partner',
      foreignKey: {
        name: 'partnerId',
      },
      constraints: false,
    });

    db.barter_offers.belongsTo(db.kooperatif, {
      as: 'kooperatif',
      foreignKey: {
        name: 'kooperatifId',
      },
      constraints: false,
    });

    db.barter_offers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.barter_offers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return barter_offers;
};
